module CreateChannel where


import Channel
import Connectors

import Control.Concurrent as CC 
import Control.Exception
import Control.Monad
import MyQSem as MS
import System.IO.Unsafe
import System.IO
import Random
import Char


------------------------------------------------- SYNCHRONOUS
newSync :: String -> String -> IO (Channel i i)
newSync idw idr = do 
       buffer <- newEmptyMVar 
       read1 <- newMVar buffer
       write1 <- newMVar buffer
       canI' <- CC.newQSem 0 
       wsyncL <- newMVar []
       rsyncL <- newMVar []
       rep <- newMVar 1
       oo <- newMVar True
       return Channel { writeC = [Prt {idp=idw, hole=write1}], 
                        readC = [Prt {idp=idr, hole=read1}], 
                        fC = id, canI = canI', writeSyncList = wsyncL, readSyncList = rsyncL,
                        writeRep = rep, readRep = rep, writeSync = rep, readSync = rep,
                        onlyOne = oo
                      }

----------------------------------------------------- TEST SYNCRONOUS
-- ok
testSync = do
                ch <- newSync "w1" "r1"
                forkIO (readCh ch "r1" >>= putStrLn.show ) 
                forkIO (writeCh ch 'a' "w1") 
                forkIO (readCh ch "r1" >>= putStrLn.show ) 
                forkIO (writeCh ch 'b' "w1" ) 
                forkIO (writeCh ch 'c' "w1" ) 
                forkIO (writeCh ch 'd' "w1" ) 
                forkIO (writeCh ch 'e' "w1" ) 
                forkIO (writeCh ch 'f' "w1" ) 
                forkIO (readCh ch "r1" >>= putStrLn.show ) 
                forkIO (readCh ch "r1" >>= putStrLn.show ) 


-- ok
testSync2 = do
                ch <- newSync "w1" "r1"
                forkIO (writeCh ch () "w1" >> putStrLn "1") 
                forkIO (putStrLn "nao da...") 
                forkIO (writeCh ch () "w1" >> putStrLn "2")

-- ok
testSync21 = do
                ch <- newSync "w1" "r1"
                forkIO (writeCh ch () "w1" >> putStrLn "1") 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (readCh ch "r1" >>= putStrLn.show)

-- ok
testSync3 = do
                ch <- newSync "w1" "r1"
                forkIO (writeCh ch () "w1") 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (writeCh ch () "w1") 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (writeCh ch () "w1") 
                forkIO (readCh ch "r1" >>= putStrLn.show)

-- ok
testSync4 = do
                ch <- newSync "w1" "r1"
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (writeCh ch "escrito" "w1" >> putStrLn "1")


---------------------------------------------- ASINCHRONOUS
newAsync :: String -> String -> IO (Channel i i)
newAsync idw idr = do 
       buffer <- newEmptyMVar 
       read1 <- newMVar buffer
       write1 <- newMVar buffer
       canI' <- CC.newQSem maxBound  
       syncL <- newMVar []
       syncM <- newMVar 1
       rep <- newMVar 1
       oo <- newMVar True
       return Channel { writeC = [Prt {idp = idw, hole = write1}], 
                        readC = [Prt {idp = idr, hole = read1}], 
                        fC = id, canI = canI', writeSyncList = syncL, readSyncList = syncL,
                        writeRep = rep, readRep = rep, writeSync = syncM, readSync = syncM,
                        onlyOne = oo
                      }
----------------------------------------------TEST ASYNCRONOUS
-- ok
testAsync = do
                ch <- newAsync "w1" "r1"
                forkIO (writeCh ch 'a' "w1" >> putStrLn "wrt 1") 
                forkIO (writeCh ch 'b' "w1" >> putStrLn "wrt 2") 
                forkIO (writeCh ch 'c' "w1" >> putStrLn "wrt 3")
                forkIO (readCh ch "r1" >>= putStrLn.show)

-- ok
testAsync2 = do
                ch <- newAsync "w1" "r1"
                forkIO (writeCh ch 'a' "w1") 
                forkIO (writeCh ch 'b' "w1") 
                forkIO (writeCh ch 'c' "w1") 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (readCh ch "r1" >>= putStrLn.show)


------------------------------------------------- LOSSY
newLossy idw idr g = do 
        buffer <- newEmptyMVar 
        read1 <- newMVar buffer
        write1 <- newMVar buffer
        canI' <- CC.newQSem maxBound 
        syncL <- newMVar []
        syncM <- newMVar 1
        oo <- newMVar True
        hc <- newMVar Nothing        
        return Channel { writeC = [Prt {idp = idw, hole = write1}], 
                        readC = [Prt {idp = idr, hole = read1}], 
                        fC = g, canI = canI', writeSyncList = syncL, readSyncList = syncL,
                        writeSync = syncM, readSync = syncM, writeRep = syncM, readRep = syncM,
                        onlyOne = oo 
                      }

------------------------------------------------- TEST LOSSY
-- ok
testLossy = do
                ch <- newLossy "w1" "r1" id
                forkIO (writeCh ch 'a' "w1" >> putStrLn "wt a") 
                forkIO (writeCh ch 'b' "w1" >> putStrLn "wt b") 
                forkIO (writeCh ch 'c' "w1" >> putStrLn "wt c") 
                forkIO (readCh ch "r1" >>= putStrLn.show) 
                forkIO (readCh ch "r1" >>= putStrLn.show)



--------------------------------------- MERGER
newMerger w1 w2 r 
  =
    do 
 buffer <- newEmptyMVar
 read <- newMVar buffer
 write1 <- newMVar buffer
 canI' <- CC.newQSem 1
 wsyncL <- newMVar []
 rsyncL <- newMVar []
 rep <- newMVar 1
 oo <- newMVar True
 return $ Channel { writeC = [Prt {idp = w1, hole = write1}, Prt {idp = w2, hole = write1}], 
                    readC = [Prt {idp = r, hole = read}], 
                    fC = id, canI = canI', writeSyncList = wsyncL, readSyncList = rsyncL,
                    writeRep = rep, readRep = rep, writeSync = rep, readSync = rep,
                    onlyOne = oo
                  } 

---------------------------------- TEST MERGER
-- ok
testMerger = do
            mg <- newMerger "w1" "w2" "r"
            forkIO (writeCh mg 'a' "w1" >> putStrLn "wrt 1") 
            forkIO (writeCh mg 'b' "w1" >> putStrLn "wrt 2") 
            forkIO (writeCh mg 'c' "w2" >> putStrLn "wrt 3") 
            forkIO (writeCh mg 'd' "w1" >> putStrLn "wrt 4") 
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (writeCh mg 'e' "w1" >> putStrLn "wrt 7") 
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (readCh mg "r" >>= putStrLn.show) 



------------------------------------------ CONCENTRATOR
newConcentrator w1 w2 r 
  =
    do 
    buffer <- newEmptyMVar
    read <- newMVar buffer
    write1 <- newMVar buffer
    canI' <- CC.newQSem maxBound
    x <- geraList [w1, w2] 20
    wsyncL <- newMVar $ x   
    rsyncL <- newMVar []
    readS <- newMVar 1
    writeS <- newMVar 2
    readR <- newMVar 1
    writeR <- newMVar 1
    oo <- newMVar False
    hc <- newMVar Nothing
    return $ Channel { writeC = [Prt {idp = w1, hole = write1}, Prt {idp = w2, hole = write1}], 
                       readC = [Prt {idp = r, hole = read}], 
                       fC = id, canI = canI', writeSyncList = wsyncL, readSyncList = rsyncL,
                       writeRep = writeR, readRep = readR, writeSync = writeS, readSync = readS,
                       onlyOne = oo
                     } 

------------------------------------- TEST CONCENTRATOR
-- ok
testConcentrator = do
            mg <- newConcentrator "w1" "w2" "r"
            putStrLn "mg"
            forkIO (writeCh mg 'a' "w1" >> putStrLn "wrt 1") 
            forkIO (writeCh mg 'a' "w2" >> putStrLn "wrt 2")
            forkIO (writeCh mg 'b' "w2" >> putStrLn "wrt 2")
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (writeCh mg 'b' "w1" >> putStrLn "wrt 1")
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (readCh mg "r" >>= putStrLn.show) 


-- ok
testConcentrator2 = do
            mg <- newConcentrator "w1" "w2" "r"
            forkIO (writeCh mg 'a' "w1" >> putStrLn "wrt 1") 
            forkIO (writeCh mg 'c' "w1" >> putStrLn "wrt 2") 
            forkIO (writeCh mg 'c' "w2" >> putStrLn "wrt 3") 
            forkIO (writeCh mg 'b' "w2" >> putStrLn "wrt 4") 
            forkIO $ showCh mg >>= putStrLn 
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (readCh mg "r" >>= putStrLn.show) 
            forkIO (readCh mg "r" >>= putStrLn.show)


---------------------------------------------------- BROADCASTER
newSBroadcaster w r1 r2 =
    do 
    buffer <- newEmptyMVar
    read1 <- newMVar buffer
    write <- newMVar buffer
    canI' <- CC.newQSem maxBound
    wsyncL <- newMVar []
    x <- geraList [r1, r2] 10
    rsyncL <- newMVar x
    wsyncL <- newMVar []
    wrep <- newMVar 2
    rrep <- newMVar 1
    oo <- newMVar True
    hc <- newMVar Nothing
    return $ Channel { writeC = [Prt {idp = w, hole = write}], 
                       readC = [Prt {idp = r1, hole = read1}, Prt {idp = r2, hole = read1}], 
                       fC = id, canI = canI', writeSyncList = wsyncL, readSyncList = rsyncL,
                       writeRep = wrep, readRep = rrep, writeSync = rrep, readSync = wrep,
                       onlyOne = oo 
                     } 

------------------------------------------ TEST BROADCASTER
-- ok
testSBroadcaster = 
    do    
    bc <- newSBroadcaster "w" "r1" "r2"
    forkIO  (writeCh bc 'a' "w" >> putStrLn "wrt 1") 
    forkIO  (writeCh bc 'b' "w" >> putStrLn "wrt 2") 
    forkIO  (writeCh bc 'c' "w" >> putStrLn "wrt 2") 
    forkIO  (readCh bc "r1" >>= \x -> putStrLn $ "|1" ++ show x ++ "1|") 
    forkIO  (readCh bc "r2" >>= \x -> putStrLn $ "|2" ++ show x ++ "2|") 
    forkIO  (readCh bc "r2" >>= \x -> putStrLn $ "|2" ++ show x ++ "2|") 
    forkIO  (readCh bc "r1" >>= \x -> putStrLn $ "|2" ++ show x ++ "2|") 
    --forkIO  (readCh bc "r2" >>= \x -> putStrLn $ "|2" ++ show x ++ "2|") 
    forkIO  (readCh bc "r1" >>= \x -> putStrLn $ "|2" ++ show x ++ "2|") 
    
    

------------------------------------------- ASYNCRONOUS DRAIN
newADrain idw1 idw2
  =  
    do
 buffer <- newEmptyMVar
 write1 <- newMVar buffer
 write2 <- newMVar buffer
 canI' <- CC.newQSem maxBound
 rep <- newMVar 1
 sync <- newMVar 1
 list <- newMVar []
 oo <- newMVar True
 return Channel { writeC = [Prt {idp = idw1, hole = write1}, Prt {idp = idw2, hole = write1}], 
                  readC = [], 
                  fC = id, canI = canI', writeRep = rep, readRep = rep,
                  writeSyncList = list, readSyncList = list, writeSync = sync, readSync =sync,      
                  onlyOne = oo
                }

------------------------------------------- TEST ASYNCRONOUS DRAIN
-- ok
testADrain = do
               ch <- newADrain "w1" "w2"
               forkIO (writeCh ch 'd' "w2" >> putStrLn "wrt 1")
               forkIO (writeCh ch 'a' "w1" >> putStrLn "wrt 2")
               forkIO (writeCh ch 'b' "w1" >> putStrLn "wrt 3")
               forkIO (writeCh ch 'c' "w1" >> putStrLn "wrt 4")
               forkIO (writeCh ch 'd' "w2" >> putStrLn "wrt 5")



------------------------------------------- SYNCRONOUS DRAIN
newSDrain idw1 idw2
  =  
    do
 buffer1 <- newEmptyMVar
 buffer2 <- newEmptyMVar
 buffer3 <- newEmptyMVar
 write1 <- newMVar buffer1
 read <- newMVar buffer1
 write2 <- newMVar buffer2
 canI' <- CC.newQSem maxBound
 rep <- newMVar 1
 wsyncM <- newMVar 2
 rsync <- newMVar []
 x <- geraList [idw1, idw2] 20
 wsync <- newMVar x
 oo <- newMVar True
 return Channel { writeC = [Prt {idp = idw1, hole = write1}, Prt {idp = idw2, hole = write1}], 
                  readC = [],
                  fC = id, canI = canI', writeSyncList = wsync, readSyncList = rsync,
                  writeRep = rep, readRep = rep, writeSync = wsyncM, readSync = rep,
                  onlyOne = oo
                }
        
------------------------------------------- TEST SYNCRONOUS DRAIN
-- ok
testSDrain2 = do
    ch <- newSDrain "w1" "w2"
    forkIO (writeCh ch 'a' "w1" >> putStrLn "wrt 1") 

-- ok
testSDrain3 = do
    ch <- newSDrain "w1" "w2"
    forkIO (writeCh ch 'a' "w1" >> putStrLn "wrt 1") 
    forkIO (writeCh ch 'b' "w1" >> putStrLn "wrt 2") 
    forkIO (writeCh ch 'c' "w2" >> putStrLn "wrt 3") 
    forkIO (writeCh ch 'd' "w1" >> putStrLn "wrt 4") 
    forkIO (writeCh ch 'e' "w1" >> putStrLn "wrt 5") 
    forkIO (writeCh ch 'f' "w2" >> putStrLn "wrt 6") 



-------------------------------------------------- AUXILIAR --------------------------------

-- show function
showr x = do y <- x
             putStrLn $ show y

geraList l 0 = return []
geraList l n = 
    do 
    qs <- newQSemN 0
    resto <- geraList l (n-1)
    return ((l, qs, Nothing):resto)
