module NewChannel where


import Channel
import CreateChannel


data NewChannel i o = 
                  Sync String String 
                | Async String String 
                | Lossy String String (i -> o)
                | Merger String String String
                | Concentrator String String String
                | SyncBroadcaster String String String
                | AsyncDrain String String
                | SyncDrain String String
                

newChannel :: NewChannel i i -> IO (Channel i i)
newChannel (Sync w r) = newSync w r
newChannel (Async w r) = newAsync w r
newChannel (Lossy w r f) = newLossy w r f
newChannel (Merger w1 w2 r) = newMerger w1 w2 r
newChannel (Concentrator w1 w2 r) = newConcentrator w1 w2 r
newChannel (SyncBroadcaster w r1 r2) = newSBroadcaster w r1 r2
newChannel (AsyncDrain w1 w2) = newADrain w1 w2
newChannel (SyncDrain w1 w2) = newSDrain w1 w2

